import 'package:flutter/material.dart';

final String package = 'senior_design_tokens';

enum SeniorTypographyTokens {
  h1,
  h2,
  h3,
  h4,
  CTA,
  title,
  text,
  body,
  small,
  helper,
  tiny,
}

class SeniorTypography {
  SeniorTypography._();

  static TextStyle h1({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.w700,
      fontFamily: 'Inter',
      fontSize: 40.0,
      color: color,
    );
  }

  static TextStyle h2({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.w600,
      fontFamily: 'Inter',
      fontSize: 32.0,
      color: color,
    );
  }

  static TextStyle h3({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.w500,
      fontFamily: 'Inter',
      fontSize: 24.0,
      color: color,
    );
  }

  static TextStyle h4({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.w500,
      fontFamily: 'Inter',
      fontSize: 20.0,
      color: color,
    );
  }

  static TextStyle cta({Color? color}) {
    return TextStyle(
      package: package,
      fontFamily: 'Inter',
      fontWeight: FontWeight.w700,
      fontSize: 18.0,
      color: color,
    );
  }

  static TextStyle title({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.w500,
      fontFamily: 'Inter',
      fontSize: 16.0,
      color: color,
    );
  }

  static TextStyle text({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.w400,
      fontFamily: 'OpenSans',
      fontSize: 16.0,
      color: color,
    );
  }

  static TextStyle body({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.w400,
      fontFamily: 'OpenSans',
      fontSize: 14.0,
      color: color,
    );
  }

  static TextStyle small({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.w400,
      fontFamily: 'OpenSans',
      fontSize: 12.0,
      color: color,
    );
  }

  static TextStyle smallBold({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.bold,
      fontFamily: 'OpenSans',
      fontSize: 12.0,
      color: color,
    );
  } 

  static TextStyle helper({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.w400,
      fontFamily: 'OpenSans',
      fontSize: 12.0,
      color: color,
    );
  }

  static TextStyle tiny({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.w500,
      fontFamily: 'Inter',
      fontSize: 10.0,
      color: color,
    );
  }

  static TextStyle titleCardRegular({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.normal,
      fontFamily: 'Inter',
      fontSize: 16.0,
      color: color,
    );
  }

  static TextStyle titleCardBold({Color? color}) {
    return TextStyle(
      package: package,
      fontWeight: FontWeight.bold,
      fontFamily: 'Inter',
      fontSize: 16.0,
      color: color,
    );
  }
}

class SeniorTypographyIconSize {
  SeniorTypographyIconSize._();

  /// This icon size is represented by 40 pixels.
  static const double h1 = 40.0;

  /// This icon size is represented by 32 pixels.
  static const double h2 = 32.0;

  /// This icon size is represented by 24 pixels.
  static const double h3 = 24.0;

  /// This icon size is represented by 20 pixels.
  static const double h4 = 20.0;

  /// This icon size is represented by 18 pixels.
  static const double CTA = 18.0;

  /// This icon size is represented by 16 pixels.
  static const double title = 16.0;

  /// This icon size is represented by 16 pixels.
  static const double text = 16.0;

  /// This icon size is represented by 14 pixels.
  static const double body = 14.0;

  /// This icon size is represented by 12 pixels.
  static const double small = 12.0;

  /// This icon size is represented by 12 pixels.
  static const double helper = 12.0;

  /// This icon size is represented by 10 pixels.
  static const double tiny = 10.0;
}
